# Linux 101

You should be able to navigate a system on a command line level. Especially in HPC you should not count on the existence of GUIs. Even though we will do all exercises in Jupyter Hub you still need to navigate the command line for setting up everything. And it does no harm to know how to use the command line ;)

Side note: Windows does offer its own command line (CMD, Powershell), but we will not cover this. If you want to stay with Windows and work locally you can give [WSL](https://docs.microsoft.com/en-us/windows/wsl/) a try.

There are different kinds of commands you can use within your terminal: shell builtins and programs. TODO 
It's nice to know that the distinction exists but you do not need to worry about it.
TODO: Be careful about case sensitivity and whitespaces


## Basics
TODO:  
1. man pages (man man)
2. pwd
3. ls
4. mkdir
5. cd
6. touch
7. mv
8. cp
9. rm (inkl. Warnung, dass das i.d.R. unwiderruflich)
10. echo
11. cat
12. head
13. tail
14. diff
15. history
16. exit

## Intermediate
TODO:  
1. Pipes
2. less
3. find
4. chmod
5. wget


## SSH
TODO:  
1. Generelle Verwendung von ssh
2. Einrichtung von Schlüsseln
3. Sachen kopieren mit scp