# Agenda

Course material repository:  https://gitlab.dkrz.de/pythoncourse/material/

## Day 1

<table width=900px>
  <tr bgcolor="lightblue" height="60">
    <th width=100 bgcolor="#87CEEB"> Day 1   </th>
    <th width=500 bgcolor="#87CEEB"> Content </th>
    <th width=300 bgcolor="#87CEEB"> docs    </th>
    <th width=70  bgcolor="#87CEEB"> time    </th>
    <th width=100 bgcolor="#87CEEB">         </th>
  </tr>
    
  <tr>
    <td style="vertical-align:top">09:00</td>
    <td><b>Session 1 : </b> Difference between mistral and a mobile phone
        <ul><li>what is a node, cpu</li>
            <li>Historical development (Boole, Shannon, Turing,....)</li>
            <li>Architecture: Von-Neumann Model, CPU and registers, Fetch-Decode-Execute-Cycle (GHz)</li>
        </ul>
        Zoo of programming languages
        <ul><li>Difference between programming language and Python</li>
            <li>Assembler, compiler, interpreter = help them to understand python</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [INTRO.md](INTRO.md) </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>
    
  <tr>
    <td>10:00</td>
    <td>Break</td>
    <td></td>
    <td></td>
    <td></td>
  </tr>

  <tr>
    <td style="vertical-align:top">10:15</td>
    <td><b>Session 2 : </b> Introduction to Linux system and setting up work environment
        <ul><li>terminal</li>
            <li>via WSL</li>
            <li>command line and shell: (basics to transfer/run files and data in/out Mistral)<br>
                cd, pwd, mkdir, rm( -r), (s)cp, ls, chmod, ssh,..<br>
                environment variables</li>
            <li>editor</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [intro to linux](./introduction_linux.md) </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Jannek<br>practice with Ralf</td>
  </tr>
   
   <tr>
    <td bgcolor="lightblue" >11:15</td>
    <td bgcolor="lightblue" >Break</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>
 
  <tr>
    <td style="vertical-align:top">11:30</td>
    <td><b>Session 3 : </b> Installation
        <ul>
            <li>conda (mamba for the speeeeed)</li>
            <li>python</li>
            <li>modules/environments
                <ul>
                    <li> envkernel conda --name=kernel-name --user $conda-env </li>
                </ul>
            </li>
            <li>python-related package management</li>
            <li>testing installation and libraries</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [conda_introduction.ipynb](./notebooks/conda_introduction.ipynb) </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Fabian</td>
  </tr>
    
  <tr>
    <td>12:00</td>
    <td>Lunch</td>
    <td></td>
    <td>1.0</td>
    <td></td>
  </tr>

  <tr>
    <td style="vertical-align:top">13:00</td>
    <td><b>Session 4 : </b> Version control, code sharing
        <ul><li>git</li>
            <li>gitlab</li>
            <li>get the workshop material (in $HOME)</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [git_intro.ipynb](./notebooks/git_intro.ipynb) </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>
   
  <tr>
    <td style="vertical-align:top">13:30</td>
    <td><b>Session 5 : </b> Jupyter notebooks
        <ul><li>Jupyter hub</li>
            <li>Jupyter lab</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [jupyter.ipynb](./notebooks/jupyter.ipynb) </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Fabian</td>
  </tr>
  <tr>
    <td style="vertical-align:top">13:30</td>
    <td><b>Session 6 : </b> Debugging of your installations
        <ul><li>is conda working?</li>
            <li>what problems do you have</li>
        </ul>
    </td>
    <td style="vertical-align:top"> </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top"></td>
  </tr>
  <tr>
    <td bgcolor="lightblue" >15:30</td>
    <td bgcolor="lightblue" >End</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>
</table> 


## Day 2 

<table width=900px>
  <tr bgcolor="lightblue" height="60">
    <th width=100 bgcolor="#87CEEB"> Day 2   </th>
    <th width=500 bgcolor="#87CEEB"> Content </th>
    <th width=300 bgcolor="#87CEEB"> docs    </th>
    <th width=70  bgcolor="#87CEEB"> time    </th>
    <th width=100 bgcolor="#87CEEB">         </th>
  </tr>
  
  <tr>
    <td style="vertical-align:top">09:00</td>
      <td><b>Warm-up : </b> warmup about content of Day 1</td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.01</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>
    
  <tr>
    <td style="vertical-align:top">09:05</td>
      <td><b>Session 1 : </b> Syntax
        <ul><li>case-sensitive</li>
            <li>print</li>
            <li>indentation and code blocks</li>
            <li>line continuation</li>
            <li>comments</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [python_core_language_part1.ipynb](./notebooks/python_core_language_part1.ipynb) </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">09:20</td>
      <td><b>Session 2 : </b> Variables
        <ul><li>assignment</li>
            <li>names and reserved names</li>
            <li>Call by Value vs Call by Reference</li>
        </ul>
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">09:35</td>
      <td><b>Session 3 : </b> Data types
        <ul><li>boolean</li>
            <li>integer</li>
            <li>floating-point</li>
            <li>complex</li>
            <li>conversion between types</li>
            <li>None</li>
        </ul>
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">09:50</td>
      <td><b>Session 4 : </b> Strings
        <ul><li>formatting</li>
            <li>string functions</li>
        </ul>
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">10:05</td>
      <td><b>Session 5 : </b> List, tuples, sets, and arrays, slices
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">10:20</td>
      <td><b>Session 6 : </b> Dictionaries
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td>11:00</td>
    <td>Break</td>
    <td></td>
    <td></td>
    <td></td>
  </tr>

  <tr>
    <td style="vertical-align:top">11:15</td>
      <td><b>Session 7 : </b> Copying objects, deep copy
    </td>
    <td style="vertical-align:top"> [python_core_language_part2.ipynb](./notebooks/python_core_language_part2.ipynb) </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">11:30</td>
      <td><b>Session 8 : </b> Mathematical operators and math functions
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">11:45</td>
      <td><b>Session 9 : </b> Conditional statements
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">12:15</td>
      <td><b>Session 10 : </b> Loops
        <ul><li>enumerate</li>
            <li>items</li>
            <li>zip</li>
        </ul>
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

  <tr>
    <td style="vertical-align:top">12:45</td>
      <td><b>Session 11 : </b> List comprehensions
        <ul><li>enumerate</li>
            <li>items</li>
            <li>zip</li>
        </ul>
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Marco</td>
  </tr>

   <tr>
    <td bgcolor="lightblue" >13:00</td>
    <td bgcolor="lightblue" >Lunch</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>

  <tr>
    <td style="vertical-align:top">14:00</td>
      <td><b>Session 12 : </b> Functions
    </td>
    <td style="vertical-align:top"> [python_core_language_part3.ipynb](./notebooks/python_core_language_part3.ipynb) </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">Jannek</td>
  </tr>

  <tr>
    <td style="vertical-align:top">14:15</td>
      <td><b>Session 13 : </b> Classes and methods
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Jannek</td>
  </tr>

  <tr>
    <td bgcolor="lightblue" >15:15</td>
    <td bgcolor="lightblue" >End</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>

</table> 

## Day 3

<table width=900px>
  <tr bgcolor="lightblue" height="60">
    <th width=100 bgcolor="#87CEEB"> Day 3   </th>
    <th width=500 bgcolor="#87CEEB"> Content </th>
    <th width=300 bgcolor="#87CEEB"> docs    </th>
    <th width=70  bgcolor="#87CEEB"> time    </th>
    <th width=100 bgcolor="#87CEEB">         </th>
  </tr>

  <tr>
    <td style="vertical-align:top">09:00</td>
      <td><b>Warm-up : </b> warmup about content of Day 2</td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.01</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>
    
  <tr>
    <td style="vertical-align:top">09:05</td>
      <td><b>Session 1 : </b> File I/O (file and stdin)
        <ul><li>open, close</li>
            <li>read</li>
            <li>write</li>
            <li>csv.reader</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [file_input_output.ipynb](./notebooks/file_input_output.ipynb) </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Jannek</td>
  </tr>

  <tr>
    <td style="vertical-align:top">09:35</td>
      <td><b>Session 2 : </b> Module numpy
    </td>
    <td style="vertical-align:top"> [numpy_intro.ipynb](./notebooks/numpy_intro.ipynb) </td>
    <td style="vertical-align:top">1.5</td>
    <td style="vertical-align:top">Jannek</td>
  </tr>
  
  <tr>
    <td>11:05</td>
    <td>Break</td>
    <td></td>
    <td></td>
    <td></td>
  </tr>

  <tr>
    <td style="vertical-align:top">11:20</td>
      <td><b>Session 3 : </b> Read/Write netCDF, GRIB files
        <ul><li>xarray</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [xarray_introduction-part1.ipynb](./notebooks/xarray_introduction-part1.ipynb)<br>[xarray_introduction-part2.ipynb](./notebooks/xarray_introduction-part2.ipynb) </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Fabian</td>
  </tr>

  <tr>
    <td style="vertical-align:top">12:20</td>
      <td><b>Session 4 : </b> Exceptions/Error handling/Logging, and Debugging
        <ul><li>try, except</li>
            <li>logging</li>
            <li>debugger</li>
        </ul>
    </td>
    <td style="vertical-align:top">[DEBUG.md](./DEBUG.md)  </td>
    <td style="vertical-align:top">0.5</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>

   <tr>
    <td bgcolor="lightblue" >12:50</td>
    <td bgcolor="lightblue" >Lunch</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>

  <tr>
    <td style="vertical-align:top">13:50</td>
      <td><b>Session 5 : </b> Data analysis
        <ul><li>python-cdo</li>
            <li>SciPy</li>
            <li>seaborn</li>
            <li>geocat-comp</li>
            <li>Iris</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [cdo_introduction.ipynb](./notebooks/cdo_introduction.ipynb) </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>

  <tr>
    <td style="vertical-align:top">13:50</td>
      <td><b>Session 6 : </b> Python in Action (GLOBAGRIM)
        <ul><li>https://github.com/MarcoKulueke/globagrim_project</li>
        </ul>
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">1.0</td>
    <td style="vertical-align:top">Marco</td>
  </tr>
  
  <tr>
    <td bgcolor="lightblue" >15:30</td>
    <td bgcolor="lightblue" >End</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>
 
</table> 

## Day 4

<table width=900px>
  <tr bgcolor="lightblue" height="60">
    <th width=100 bgcolor="#87CEEB"> Day 4   </th>
    <th width=500 bgcolor="#87CEEB"> Content </th>
    <th width=300 bgcolor="#87CEEB"> docs    </th>
    <th width=70  bgcolor="#87CEEB"> time    </th>
    <th width=100 bgcolor="#87CEEB">         </th>
  </tr>

  <tr>
    <td style="vertical-align:top">09:00</td>
      <td><b>Warm-up : </b> warmup about content of Day 3</td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.01</td>
    <td style="vertical-align:top">Ralf</td>
  </tr>
    
  <tr>
    <td style="vertical-align:top">09:05</td>
      <td><b>Session 1 : </b> Visualization
        <ul><li>Matplotlib</li>
            <li>Cartopy</li>
            <li>numpy's plot</li>
            <li>xarray's plot</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [visualization_with_Matplotlib_L1.ipynb](./notebooks/visualization_with_Matplotlib_L1.ipynb)<br>[visualization_with_Matplotlib_L2.ipynb](./notebooks/visualization_with_Matplotlib_L2.ipynb) </td>
    <td style="vertical-align:top">1.5</td>
    <td style="vertical-align:top">Jannek</td>
  </tr>

  <tr>
    <td>10:35</td>
    <td>Break</td>
    <td></td>
    <td></td>
    <td></td>
  </tr>

  <tr>
    <td style="vertical-align:top">10:50</td>
      <td><b>Session 2 : </b> Interesting packages
        <ul><li>json/yaml</li>
            <li>argparse</li>
            <li>tqdm</li>
            <li>re</li>
            <li>subprocess</li>
            <li>typing</li>
            <li>tempfile</li>
        </ul>
    </td>
    <td style="vertical-align:top"> [packages_collection.ipynb](./notebooks/packages_collection.ipynb)<br>[packages_collection_argparse.ipynb](./notebooks/packages_collection_argparse.ipynb) </td>
    <td style="vertical-align:top">1.5</td>
    <td style="vertical-align:top">Jannek</td>
  </tr>

   <tr>
    <td bgcolor="lightblue" >12:20</td>
    <td bgcolor="lightblue" >Lunch</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>

  <tr>
    <td style="vertical-align:top">13:20</td>
      <td><b>Session 3 : </b> Exercise
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">2.0</td>
    <td style="vertical-align:top">@all</td>
  </tr>

  <tr>
    <td style="vertical-align:top">15:20</td>
      <td><b>Session 4 : </b> Feedback
    </td>
    <td style="vertical-align:top">  </td>
    <td style="vertical-align:top">0.25</td>
    <td style="vertical-align:top">@all</td>
  </tr>

  <tr>
    <td bgcolor="lightblue" >15:45</td>
    <td bgcolor="lightblue" >This is the End</td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
    <td bgcolor="lightblue" ></td>
  </tr>
  
</table> 
