# GloBaGriM Exercise

## 1. Instability
Let the model run with the following parameters: ``NJ = ?``, ``NK = ?``, ``DT = ?``

## 2. Visualization
You may have noticed that the model produces unrealistic values. The model becomes unstable. This happens when either the temporal resolution is too coarse or the spatial resolution is too fine.

Visualize the moment and place where the model becomes unstable with Matplotlib and Cartopy.

## 3. Procuce a Stable Model Run
Change the integration time step ``DT`` in order to achieve a stable model run. Compare your results with the unstable model run during various time steps.

Hint: Satisfying [The Courant–Friedrichs–Lewy condition](https://en.wikipedia.org/wiki/Courant%E2%80%93Friedrichs%E2%80%93Lewy_condition) helps you to keep the modle stable.
